Index: src/mlx/gui/common.py
===================================================================
--- src/mlx/gui/common.py	(revision 220)
+++ src/mlx/gui/common.py	(revision 221)
@@ -227,2 +227,11 @@
 
 #------------------------------------------------------------------------------
+
+def formatFlightLogLine(timeStr, line):
+    """Format the given flight log line."""
+    """Format the given line for flight logging."""
+    if timeStr is not None:
+        line = timeStr + ": " + line
+    return line + "\n"
+
+#------------------------------------------------------------------------------
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 220)
+++ src/mlx/gui/gui.py	(revision 221)
@@ -33,11 +33,4 @@
 class GUI(fs.ConnectionListener):
     """The main GUI class."""
-    @staticmethod
-    def _formatFlightLogLine(timeStr, line):
-        """Format the given line for flight logging."""
-        if timeStr is not None:
-            line = timeStr + ": " + line
-        return line + "\n"
-        
     def __init__(self, programDirectory, config):
         """Construct the GUI."""
@@ -473,5 +466,5 @@
         """Write the given message line to the log."""
         gobject.idle_add(self._writeLog,
-                         GUI._formatFlightLogLine(timeStr, line),
+                         formatFlightLogLine(timeStr, line),
                          self._logView)
 
@@ -479,5 +472,5 @@
         """Update the line with the given index."""
         gobject.idle_add(self._updateFlightLogLine, index,
-                         GUI._formatFlightLogLine(timeStr, line))
+                         formatFlightLogLine(timeStr, line))
 
     def _updateFlightLogLine(self, index, line):
Index: src/mlx/gui/pirep.py
===================================================================
--- src/mlx/gui/pirep.py	(revision 220)
+++ src/mlx/gui/pirep.py	(revision 221)
@@ -131,6 +131,25 @@
         
         contentArea = self.get_content_area()
+
+        self._notebook = gtk.Notebook()
+        contentArea.pack_start(self._notebook, False, False, 4)
+        
         dataTab = self._buildDataTab()
-        contentArea.pack_start(dataTab, False, False, 0)
+        label = gtk.Label(xstr("pirepView_tab_data"))
+        label.set_use_underline(True)
+        label.set_tooltip_text(xstr("pirepView_tab_data_tooltip"))
+        self._notebook.append_page(dataTab, label)
+        
+        commentsTab = self._buildCommentsTab()
+        label = gtk.Label(xstr("pirepView_tab_comments"))
+        label.set_use_underline(True)
+        label.set_tooltip_text(xstr("pirepView_tab_comments_tooltip"))
+        self._notebook.append_page(commentsTab, label)
+        
+        logTab = self._buildLogTab()
+        label = gtk.Label(xstr("pirepView_tab_log"))
+        label.set_use_underline(True)
+        label.set_tooltip_text(xstr("pirepView_tab_log_tooltip"))
+        self._notebook.append_page(logTab, label)
         
     def setPIREP(self, pirep):
@@ -205,5 +224,16 @@
             delayCodes += PIREP.delayCodes[code]
         
-        self._delayCodes.get_buffer().set_text(delayCodes)
+        self._delayCodes.get_buffer().set_text(delayCodes)        
+
+        self._comments.get_buffer().set_text(pirep.comments)
+        self._flightDefects.get_buffer().set_text(pirep.flightDefects)
+
+        logBuffer = self._log.get_buffer()
+        logBuffer.set_text("")
+        for (timeStr, line) in pirep.logLines:
+            logBuffer.insert(logBuffer.get_end_iter(), 
+                             formatFlightLogLine(timeStr, line))
+
+        self._notebook.set_current_page(0)
 
     def _buildDataTab(self):
@@ -437,4 +467,5 @@
         table.set_row_spacings(4)
         table.set_col_spacings(8)
+        table.set_homogeneous(False)
         
         self._blockTimeStart = \
@@ -501,6 +532,35 @@
         return frame        
 
+    def _buildCommentsTab(self):
+        """Build the tab with the comments and flight defects."""
+        table = gtk.Table(2, 1)
+        table.set_col_spacings(16)
+
+        (frame, commentsBox) = \
+            PIREPViewer.createFrame(xstr("pirepView_comments"))
+        table.attach(frame, 0, 1, 0, 1)
+
+        (commentsWindow, self._comments) = \
+            PIREPViewer.getTextWindow(heightRequest = -1)
+        commentsBox.pack_start(commentsWindow, True, True, 0)
+
+        (frame, flightDefectsBox) = \
+            PIREPViewer.createFrame(xstr("pirepView_flightDefects"))
+        table.attach(frame, 1, 2, 0, 1)
+
+        (flightDefectsWindow, self._flightDefects) = \
+            PIREPViewer.getTextWindow(heightRequest = -1)
+        flightDefectsBox.pack_start(flightDefectsWindow, True, True, 0)
+        
+        return table
+
+    def _buildLogTab(self):
+        """Build the log tab."""
+        mainBox = gtk.VBox()
+
+        (logWindow, self._log) = PIREPViewer.getTextWindow(heightRequest = -1)
+        mainBox.pack_start(logWindow, True, True, 0)
+        
+        return mainBox
+        
 #------------------------------------------------------------------------------
-#------------------------------------------------------------------------------
-#------------------------------------------------------------------------------
-#------------------------------------------------------------------------------
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 220)
+++ src/mlx/i18n.py	(revision 221)
@@ -878,4 +878,8 @@
         self.add("pirepView_title", "PIREP viewer")
 
+        self.add("pirepView_tab_data", "_Data")
+        self.add("pirepView_tab_data_tooltip", 
+                 "The main data of the flight.")
+
         self.add("pirepView_frame_flight", "Flight")
         self.add("pirepView_callsign", "Callsign:")
@@ -921,4 +925,14 @@
         self.add("pirepView_no", "no")
         self.add("pirepView_delayCodes", "Delay codes:")
+
+        self.add("pirepView_tab_comments", "_Comments & defects")
+        self.add("pirepView_tab_comments_tooltip", 
+                 "The comments and the flight defects.")
+
+        self.add("pirepView_comments", "Comments")
+        self.add("pirepView_flightDefects", "Flight defects")
+
+        self.add("pirepView_tab_log", "_Log")
+        self.add("pirepView_tab_log_tooltip", "The flight log.")
 
 #------------------------------------------------------------------------------