Index: src/mlx/gui/common.py
===================================================================
--- src/mlx/gui/common.py	(revision 221)
+++ src/mlx/gui/common.py	(revision 225)
@@ -228,9 +228,11 @@
 #------------------------------------------------------------------------------
 
-def formatFlightLogLine(timeStr, line):
+def formatFlightLogLine(timeStr, line, isFault = False):
     """Format the given flight log line."""
     """Format the given line for flight logging."""
     if timeStr is not None:
         line = timeStr + ": " + line
+    #if isFault:
+    #    line = "<b>" + line + "</b>"
     return line + "\n"
 
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 221)
+++ src/mlx/gui/gui.py	(revision 225)
@@ -463,14 +463,15 @@
         return True
             
-    def addFlightLogLine(self, timeStr, line):
+    def addFlightLogLine(self, timeStr, line, isFault = False):
         """Write the given message line to the log."""
         gobject.idle_add(self._writeLog,
-                         formatFlightLogLine(timeStr, line),
+                         formatFlightLogLine(timeStr, line, isFault = isFault),
                          self._logView)
 
-    def updateFlightLogLine(self, index, timeStr, line):
+    def updateFlightLogLine(self, index, timeStr, line, isFault = False):
         """Update the line with the given index."""
         gobject.idle_add(self._updateFlightLogLine, index,
-                         formatFlightLogLine(timeStr, line))
+                         formatFlightLogLine(timeStr, line,
+                                             isFault = isFault))
 
     def _updateFlightLogLine(self, index, line):
Index: src/mlx/gui/pirep.py
===================================================================
--- src/mlx/gui/pirep.py	(revision 224)
+++ src/mlx/gui/pirep.py	(revision 225)
@@ -234,8 +234,13 @@
 
         logBuffer = self._log.get_buffer()
+        print dir(logBuffer)
         logBuffer.set_text("")
+        lineIndex = 0
         for (timeStr, line) in pirep.logLines:
+            isFault = lineIndex in pirep.faultLineIndexes
             logBuffer.insert(logBuffer.get_end_iter(), 
-                             formatFlightLogLine(timeStr, line))
+                             formatFlightLogLine(timeStr, line, 
+                                                 isFault = isFault))
+            lineIndex += 1
 
         self._notebook.set_current_page(0)
Index: src/mlx/logger.py
===================================================================
--- src/mlx/logger.py	(revision 160)
+++ src/mlx/logger.py	(revision 225)
@@ -56,12 +56,12 @@
         self._faultLineIndexes = []
                 
-    def message(self, timestamp, msg):
+    def message(self, timestamp, msg, isFault = False):
         """Put a simple textual message into the log with the given timestamp."""
         timeStr = util.getTimestampString(timestamp)
-        return self._logLine(msg, timeStr)
+        return self._logLine(msg, timeStr, isFault = isFault)
 
-    def untimedMessage(self, msg):
+    def untimedMessage(self, msg, isFault = False):
         """Put an untimed message into the log."""
-        return self._logLine(msg)
+        return self._logLine(msg, isFault = isFault)
 
     def debug(self, msg):
@@ -91,5 +91,5 @@
         text = "%s (NO GO)" % (what) if score==Logger.NO_GO_SCORE \
                else "%s (%.1f)" % (what, score)
-        lineIndex = self.message(timestamp, text)
+        lineIndex = self.message(timestamp, text, isFault = True)
         self._faultLineIndexes.append(lineIndex)
         (messageType, duration) = (const.MESSAGETYPE_NOGO, 10) \
@@ -118,9 +118,9 @@
         self._output.updateFlightLogLine(index, timeStr, line)
 
-    def _logLine(self, line, timeStr = None):
+    def _logLine(self, line, timeStr = None, isFault = False):
         """Log the given line."""
         index = len(self._lines)
         self._lines.append((timeStr, line))
-        self._output.addFlightLogLine(timeStr, line)
+        self._output.addFlightLogLine(timeStr, line, isFault)
         return index
         