Index: src/mlx/gui/common.py
===================================================================
--- src/mlx/gui/common.py	(revision 232)
+++ src/mlx/gui/common.py	(revision 241)
@@ -179,4 +179,8 @@
         return self._currentInteger
 
+    def reset(self):
+        """Reset the integer."""
+        self.set_int(None)
+
     def set_int(self, value):
         """Set the integer."""
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 233)
+++ src/mlx/gui/flight.py	(revision 241)
@@ -1888,10 +1888,11 @@
         self._v1 = IntegerEntry()
         self._v1.set_width_chars(4)
-        self._v1.set_tooltip_markup(xstr("takeoff_v1_tooltip"))
+        self._v1.set_tooltip_markup(xstr("takeoff_v1_tooltip_knots"))
         self._v1.connect("integer-changed", self._valueChanged)
         table.attach(self._v1, 2, 3, 2, 3)
         label.set_mnemonic_widget(self._v1)
-        
-        table.attach(gtk.Label(xstr("label_knots")), 3, 4, 2, 3)
+
+        self._v1Unit = gtk.Label(xstr("label_knots"))
+        table.attach(self._v1Unit, 3, 4, 2, 3)
         
         label = gtk.Label(xstr("takeoff_vr"))
@@ -1903,10 +1904,11 @@
         self._vr = IntegerEntry()
         self._vr.set_width_chars(4)
-        self._vr.set_tooltip_markup(xstr("takeoff_vr_tooltip"))
+        self._vr.set_tooltip_markup(xstr("takeoff_vr_tooltip_knots"))
         self._vr.connect("integer-changed", self._valueChanged)
         table.attach(self._vr, 2, 3, 3, 4)
         label.set_mnemonic_widget(self._vr)
         
-        table.attach(gtk.Label(xstr("label_knots")), 3, 4, 3, 4)
+        self._vrUnit = gtk.Label(xstr("label_knots"))
+        table.attach(self._vrUnit, 3, 4, 3, 4)
         
         label = gtk.Label(xstr("takeoff_v2"))
@@ -1918,10 +1920,11 @@
         self._v2 = IntegerEntry()
         self._v2.set_width_chars(4)
-        self._v2.set_tooltip_markup(xstr("takeoff_v2_tooltip"))
+        self._v2.set_tooltip_markup(xstr("takeoff_v2_tooltip_knots"))
         self._v2.connect("integer-changed", self._valueChanged)
         table.attach(self._v2, 2, 3, 4, 5)
         label.set_mnemonic_widget(self._v2)
         
-        table.attach(gtk.Label(xstr("label_knots")), 3, 4, 4, 5)
+        self._v2Unit = gtk.Label(xstr("label_knots"))
+        table.attach(self._v2Unit, 3, 4, 4, 5)
 
         self.addCancelFlightButton()
@@ -1968,4 +1971,15 @@
         self._v2.set_int(None)
         self._v2.set_sensitive(True)
+
+        i18nSpeedUnit = self._wizard.gui.flight.getI18NSpeedUnit()
+        speedUnit = xstr("label" + i18nSpeedUnit)
+        self._v1Unit.set_text(speedUnit)
+        self._vrUnit.set_text(speedUnit)
+        self._v2Unit.set_text(speedUnit)
+
+        self._v1.set_tooltip_markup(xstr("takeoff_v1_tooltip" + i18nSpeedUnit))
+        self._vr.set_tooltip_markup(xstr("takeoff_vr_tooltip" + i18nSpeedUnit))
+        self._v2.set_tooltip_markup(xstr("takeoff_v2_tooltip" + i18nSpeedUnit))
+
         self._button.set_sensitive(False)
         self._forwardAllowed = False
@@ -1985,4 +1999,11 @@
         self._updateForwardButton()
 
+    def reset(self):
+        """Reset the page if the wizard is reset."""
+        super(TakeoffPage, self).reset()
+        self._v1.reset()
+        self._vr.reset()
+        self._v2.reset()
+        
     def _updateForwardButton(self):
         """Update the sensitivity of the forward button based on some conditions."""
@@ -2103,10 +2124,11 @@
         self._vref = IntegerEntry()
         self._vref.set_width_chars(5)
-        self._vref.set_tooltip_markup(xstr("landing_vref_tooltip"))
+        self._vref.set_tooltip_markup(xstr("landing_vref_tooltip_knots"))
         self._vref.connect("integer-changed", self._vrefChanged)
         table.attach(self._vref, 3, 4, 5, 6)
         label.set_mnemonic_widget(self._vref)
-        
-        table.attach(gtk.Label(xstr("label_knots")), 4, 5, 5, 6)
+
+        self._vrefUnit = gtk.Label(xstr("label_knots"))
+        table.attach(self._vrefUnit, 4, 5, 5, 6)
 
         self.addCancelFlightButton()
@@ -2149,6 +2171,7 @@
         """Reset the page if the wizard is reset."""
         super(LandingPage, self).reset()
+        self._vref.reset()
         self._flightEnded = False
-
+        
     def activate(self):
         """Called when the page is activated."""
@@ -2169,4 +2192,11 @@
         self._vref.set_int(None)
         self._vref.set_sensitive(True)
+
+        i18nSpeedUnit = self._wizard.gui.flight.getI18NSpeedUnit()
+        speedUnit = xstr("label" + i18nSpeedUnit)
+        self._vrefUnit.set_text(speedUnit)
+
+        self._vref.set_tooltip_markup(xstr("landing_vref_tooltip" +
+                                           i18nSpeedUnit))
 
         self._updateForwardButton()
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 239)
+++ src/mlx/gui/gui.py	(revision 241)
@@ -338,5 +338,6 @@
         """Called when we have connected to the simulator."""
         self._connected = True
-        self._logger.untimedMessage("Connected to the simulator %s" % (descriptor,))
+        self._logger.untimedMessage("MLX %s connected to the simulator %s" % \
+                                    (const.VERSION, descriptor))
         fs.sendMessage(const.MESSAGETYPE_INFORMATION,
                        "Welcome to MAVA Logger X " + const.VERSION)