Index: src/mlx/flight.py
===================================================================
--- src/mlx/flight.py	(revision 241)
+++ src/mlx/flight.py	(revision 262)
@@ -83,4 +83,9 @@
 
     @property
+    def cargoWeight(self):
+        """Get the cargo weight for the flight."""
+        return self._gui.cargoWeight
+
+    @property
     def zfw(self):
         """Get the Zero-Fuel Weight of the flight."""
@@ -88,4 +93,9 @@
 
     @property
+    def filedCruiseAltitude(self):
+        """Get the filed cruise altitude."""
+        return self._gui.filedCruiseAltitude
+
+    @property
     def cruiseAltitude(self):
         """Get the cruise altitude of the flight."""
@@ -93,4 +103,29 @@
 
     @property
+    def route(self):
+        """Get the route of the flight."""
+        return self._gui.route
+
+    @property
+    def departureMETAR(self):
+        """Get the departure METAR of the flight."""
+        return self._gui.departureMETAR
+
+    @property
+    def arrivalMETAR(self):
+        """Get the arrival METAR of the flight."""
+        return self._gui.arrivalMETAR
+
+    @property
+    def departureRunway(self):
+        """Get the departure runway."""
+        return self._gui.departureRunway
+
+    @property
+    def sid(self):
+        """Get the SID followed."""
+        return self._gui.sid
+
+    @property
     def v1(self):
         """Get the V1 speed of the flight."""
@@ -108,4 +143,24 @@
 
     @property
+    def star(self):
+        """Get the STAR planned."""
+        return self._gui.star
+
+    @property
+    def transition(self):
+        """Get the transition planned."""
+        return self._gui.transition
+
+    @property
+    def approachType(self):
+        """Get the approach type."""
+        return self._gui.approachType
+
+    @property
+    def arrivalRunway(self):
+        """Get the arrival runway."""
+        return self._gui.arrivalRunway
+
+    @property
     def vref(self):
         """Get the VRef speed of the flight."""
@@ -116,4 +171,29 @@
         """Get the touchdown rate if known, None otherwise."""
         return self._tdRate
+
+    @property
+    def flightType(self):
+        """Get the type of the flight."""
+        return self._gui.flightType
+
+    @property
+    def online(self):
+        """Get whether the flight was an online flight."""
+        return self._gui.online
+
+    @property
+    def comments(self):
+        """Get the comments made by the pilot."""
+        return self._gui.comments
+
+    @property
+    def flightDefects(self):
+        """Get the flight defects reported by the pilot."""
+        return self._gui.flightDefects
+
+    @property
+    def delayCodes(self):
+        """Get the delay codes."""
+        return self._gui.delayCodes
 
     @property
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 242)
+++ src/mlx/gui/flight.py	(revision 262)
@@ -2546,5 +2546,5 @@
 
         if result==RESPONSETYPE_OK:
-            pirep = PIREP(gui)
+            pirep = PIREP(gui.flight)
 
             self._lastSavePath = text2unicode(dialog.get_filename())
@@ -2603,5 +2603,5 @@
     def _sendClicked(self, button):
         """Called when the Send button is clicked."""
-        pirep = PIREP(self._wizard.gui)
+        pirep = PIREP(self._wizard.gui.flight)
         self._wizard.gui.sendPIREP(pirep,
                                    callback = self._handlePIREPSent)
Index: src/mlx/pirep.py
===================================================================
--- src/mlx/pirep.py	(revision 220)
+++ src/mlx/pirep.py	(revision 262)
@@ -39,32 +39,31 @@
             return None
         
-    def __init__(self, gui):
-        """Initialize the PIREP from the given GUI."""
-        self.bookedFlight = gui.bookedFlight
-        self.cargoWeight = gui.cargoWeight
+    def __init__(self, flight):
+        """Initialize the PIREP from the given flight."""
+        self.bookedFlight = flight.bookedFlight
+        self.cargoWeight = flight.cargoWeight
         
-        self.filedCruiseAltitude = gui.filedCruiseAltitude
-        self.cruiseAltitude = gui.cruiseAltitude
-        self.route = gui.route
+        self.filedCruiseAltitude = flight.filedCruiseAltitude
+        self.cruiseAltitude = flight.cruiseAltitude
+        self.route = flight.route
 
-        self.departureMETAR = gui.departureMETAR.upper()
-        self.arrivalMETAR = gui.arrivalMETAR.upper()
+        self.departureMETAR = flight.departureMETAR.upper()
+        self.arrivalMETAR = flight.arrivalMETAR.upper()
 
-        self.departureRunway = gui.departureRunway.upper()
-        self.sid = gui.sid.upper()
+        self.departureRunway = flight.departureRunway.upper()
+        self.sid = flight.sid.upper()
 
-        self.star = gui.star
-        self.transition = gui.transition
-        self.approachType = gui.approachType.upper()
-        self.arrivalRunway = gui.arrivalRunway.upper()
+        self.star = flight.star
+        self.transition = flight.transition
+        self.approachType = flight.approachType.upper()
+        self.arrivalRunway = flight.arrivalRunway.upper()
 
-        self.flightType = gui.flightType
-        self.online = gui.online
+        self.flightType = flight.flightType
+        self.online = flight.online
 
-        self.comments = gui.comments
-        self.flightDefects = gui.flightDefects
-        self.delayCodes = gui.delayCodes
+        self.comments = flight.comments
+        self.flightDefects = flight.flightDefects
+        self.delayCodes = flight.delayCodes
         
-        flight = gui.flight
         self.blockTimeStart = flight.blockTimeStart
         self.flightTimeStart = flight.flightTimeStart
@@ -74,5 +73,5 @@
         self.fuelUsed = flight.startFuel - flight.endFuel
 
-        logger = gui.logger
+        logger = flight.logger
         self.rating = logger.getRating()
         self.logLines = logger.lines