Index: src/mlx/acft.py
===================================================================
--- src/mlx/acft.py	(revision 243)
+++ src/mlx/acft.py	(revision 263)
@@ -669,6 +669,7 @@
     - rpm: left, right
     - reverser: left, right."""
-    fuelTanks = [const.FUELTANK_LEFT_AUX, const.FUELTANK_LEFT,
-                 const.FUELTANK_RIGHT, const.FUELTANK_RIGHT_AUX]
+    fuelTanks = [const.FUELTANK_LEFT, const.FUELTANK_CENTRE, const.FUELTANK_RIGHT]    
+    # fuelTanks = [const.FUELTANK_LEFT_AUX, const.FUELTANK_LEFT,
+    #              const.FUELTANK_RIGHT, const.FUELTANK_RIGHT_AUX]
 
     def __init__(self, flight):
Index: src/mlx/checks.py
===================================================================
--- src/mlx/checks.py	(revision 243)
+++ src/mlx/checks.py	(revision 263)
@@ -572,5 +572,10 @@
         """Determine if the engines are in such a state that the lights should
         be on."""
-        return max(state.n1)>5
+        if state.n1 is not None:
+            return max(state.n1)>5
+        elif state.rpm is not None:
+            return max(state.rpm)>0
+        else:
+            return False
 
 #---------------------------------------------------------------------------------------
@@ -582,11 +587,10 @@
         """Determine if the engines are in such a state that the lights should
         be on."""
-        return max(state.n1[1:])>5
-    
+        return max(state.n1[1:])>5    
 
 #---------------------------------------------------------------------------------------
 
 class BankChecker(SimpleFaultChecker):
-    """Check for the anti-collision light being off at high N1 values."""
+    """Check for the bank is within limits."""
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds."""
@@ -973,9 +977,9 @@
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds."""
-        return flight.stage==const.STAGE_TAKEOFF and max(state.n1)>97
+        return flight.stage==const.STAGE_TAKEOFF and \
+               state.n1 is not None and max(state.n1)>97
                
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
-        print state.n1
         flight.handleFault(ThrustChecker, state.timestamp,
                            FaultChecker._appendDuring(flight,
Index: src/mlx/fs.py
===================================================================
--- src/mlx/fs.py	(revision 243)
+++ src/mlx/fs.py	(revision 263)
@@ -188,8 +188,8 @@
     - n1[]: the N1 values of the turbine engines (array of floats
     of as many items as the number of engines, present only for aircraft with
-    turbines)
+    turbines, for other aircraft it is None)
     - rpm[]: the RPM values of the piston engines (array of floats
     of as many items as the number of engines, present only for aircraft with
-    pistons)
+    pistons, for other aircraft it is None)
     - reverser[]: an array of booleans indicating if the thrust reversers are
     activated on any of the engines. The number of items equals to the number
Index: src/mlx/fsuipc.py
===================================================================
--- src/mlx/fsuipc.py	(revision 243)
+++ src/mlx/fsuipc.py	(revision 263)
@@ -1388,9 +1388,12 @@
             self._addOffsetWithIndexMember(data, offset+4, "u")  # tank capacity
 
-        if self._isN1:
-            self._engineStartIndex = len(data)
-            for i in range(0, self._numEngines):
+        self._engineStartIndex = len(data)
+        for i in range(0, self._numEngines):
+            self._addOffsetWithIndexMember(data, 0x088c + i * 0x98, "h")  # throttle lever
+            if self._isN1:
                 self._addOffsetWithIndexMember(data, 0x2000 + i * 0x100, "f")  # N1
-                self._addOffsetWithIndexMember(data, 0x088c + i * 0x98, "h")  # throttle lever
+            else:
+                self._addOffsetWithIndexMember(data, 0x0898 + i * 0x98, "H")  # RPM
+                self._addOffsetWithIndexMember(data, 0x08c8 + i * 0x98, "H")  # RPM scaler
         
     def getAircraftState(self, aircraft, timestamp, data):
@@ -1410,10 +1413,19 @@
             state.fuel.append(fuel)
 
-        state.n1 = []
+
+        state.n1 = [] if self._isN1 else None
+        state.rpm = None if self._isN1 else []
+        itemsPerEngine = 2 if self._isN1 else 3
+        
         state.reverser = []
         for i in range(self._engineStartIndex,
-                       self._engineStartIndex + 2*self._numEngines, 2):
-            state.n1.append(data[i])
-            state.reverser.append(data[i+1]<0)
+                       self._engineStartIndex +
+                       itemsPerEngine*self._numEngines,
+                       itemsPerEngine):
+            state.reverser.append(data[i]<0)
+            if self._isN1:
+                state.n1.append(data[i+1])
+            else:
+                state.rpm.append(data[i+1] * data[i+2]/65536.0)
 
         return state
@@ -1605,10 +1617,10 @@
             __init__(flapsNotches = [0, 15, 30, 45],
                      fuelTanks = acft.DC3.fuelTanks,
-                     numEngines = 2)
+                     numEngines = 2, isN1 = False)
 
     @property
     def name(self):
         """Get the name for this aircraft model."""
-        return "FSUIPC/Generic Lisunov Li-2"
+        return "FSUIPC/Generic Lisunov Li-2 (DC-3)"
 
 #------------------------------------------------------------------------------
Index: src/mlx/gui/monitor.py
===================================================================
--- src/mlx/gui/monitor.py	(revision 228)
+++ src/mlx/gui/monitor.py	(revision 263)
@@ -286,10 +286,10 @@
             self._fuel.set_text(fuelStr)
 
-            if hasattr(aircraftState, "n1"):
+            if aircraftState.n1 is not None:
                 n1Str = ""
                 for n1 in aircraftState.n1:
                     if n1Str: n1Str += ", "
                     n1Str += "%.0f" % (n1,)
-            elif hasattr(aircraftState, "rpm"):
+            elif aircraftState.rpm is not None:
                 n1Str = ""
                 for rpm in aircraftState.rpm: